/**
 *	Test gethostbyname.function by DKnoto, 2012/02/04.
 */

#include <stdio.h>
#include <errno.h>
#include <netdb.h>
#include <sys/socket.h>

extern int h_errno;

int main( int argc, char *argv[] )
{
	char *hn = NULL;
	struct hostent *he = NULL;

	/**
	 *	Analiza ilości argumentów.
	 */
	switch( argc )
	{
		case 2:
		{
			hn = argv[1];
			break;
		}
		case 1:
		{
			hn = "localhost";
			break;
		}
		default:
		{
			printf( "Erro: bad arguments number\n" );
			return 1;
			break;
		}
	}

	/**
	 *
	 */
	printf( "Host in \"%s\"\n", hn );
	he = gethostbyname( hn );
	if( he )
	{
		int i = 0;
		printf( "  h_name == \"%s\"\n", he->h_name );
		while( he->h_aliases[i] )
		{
			printf( "  h_aliases[%d] == \"%s\"\n", i, he->h_aliases[i] );
			i++;
		}
		printf( "  h_addrtype == %d\n", he->h_addrtype );
		printf( "  h_length   == %d\n", he->h_length );

		i = 0;
		while( he->h_addr_list[i] )
		{
			int j = 0;
			printf( "  h_addr_list[%d] == %d", i,
				(unsigned char)(he->h_addr_list[i][j]) );
			for( j++; j < he->h_length; j++ )
			{
				printf( ".%d", (unsigned char)(he->h_addr_list[i][j]) );
			}
			printf( "\n" );
			i++;
		}
	}
	else
	{
		printf( "  gethostbyname( \"%s\" ): Error, errno == %d, h_errno == %d\n",
				hn, errno, h_errno );
	}

	return 0;
}

/**
 *	EOF
 */
